unit Unit12;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, MyThreadingUnit;

type
  TForm12 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FThread1 : TMyThread2;
    FThread2 : TMyThread2;
    FThread3 : TMyThread2;
    FThread4 : TMyThread2;

  public
    { Public declarations }
  end;

var
  Form12: TForm12;

implementation

{$R *.dfm}

procedure TForm12.Button1Click(Sender: TObject);
var
  AText : String;

begin
  AText := Edit1.Text;
  Memo1.Lines.Add( 'Button clicked' );

  FThread1.ExecuteProc(
      procedure()
      var
        ANewText1 : String;

      begin
        Sleep( 500 );
        ANewText1 := AText + ' + Thread1';

        FThread2.ExecuteProc(
            procedure()
            var
              ANewText2 : String;

            begin
              Sleep( 500 );
              ANewText2 := ANewText1 + ' + Thread2';

              FThread2.ExecuteProc(
                  procedure()
                  var
                    ANewText3 : String;

                  begin
                    Sleep( 500 );
                    ANewText3 := ANewText2 + ' + Thread3';

                    FThread4.ExecuteProc(
                        procedure()
                        var
                          ANewText4 : String;

                        begin
                          Sleep( 500 );
                          ANewText4 := ANewText3 + ' + Thread4';

                          FThread4.Synchronize(
                              procedure()
                              begin
                                Memo1.Lines.Add( ANewText4 );
                              end
                            );

                        end
                      );
                  end
                );

            end
          );

      end
    );

end;

procedure TForm12.FormCreate(Sender: TObject);
begin
  FThread1 := TMyThread2.Create();
  FThread2 := TMyThread2.Create();
  FThread3 := TMyThread2.Create();
  FThread4 := TMyThread2.Create();
end;

procedure TForm12.FormDestroy(Sender: TObject);
begin
  FThread1.Free();
  FThread2.Free();
  FThread3.Free();
  FThread4.Free();
end;

end.
