unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MyListUnit, Vcl.StdCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FList  : TMyList1<TMyData>;

  private
    procedure PrintItem( AItem : TMyData );

  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure GlobalPrintItem( AItem : TMyData );
begin
  Form2.Memo1.Lines.Add( Aitem.Value2 );
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear();
  FList.ForEach( PrintItem );

//  FList.ForEach( GlobalPrintItem ); // This however is not possible!
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FList := TMyList1<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

procedure TForm2.PrintItem( AItem : TMyData );
begin
  Memo1.Lines.Add( AItem.Value2 );
end;

end.
