unit Unit3;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Generics.Collections, MyListUnit,
  Vcl.StdCtrls;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FList   : TList<TMyData>;

  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

procedure TForm3.Button1Click(Sender: TObject);
var
  AItem : TMyData;

begin
  Memo1.Lines.Clear();
  for AItem in FList do
    if( AItem.Value1 = 7 ) then
      Memo1.Lines.Add( AItem.Value2 );

end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  FList := TList<TMyData>.Create();

  PopulateTestList( FList );
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

end.
