unit Unit4;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections, MyListUnit;

type
  TForm4 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FList   : TMyList1<TMyData>;
    FValue  : Integer;

  private
    procedure PrintSomeItems( AItem : TMyData );

  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear();
  FValue := 7;
  FList.ForEach( PrintSomeItems );
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  FList := TMyList1<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm4.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

procedure TForm4.PrintSomeItems( AItem : TMyData );
begin
  if( AItem.Value1 = FValue ) then
    Memo1.Lines.Add( AItem.Value2 );

end;

end.
