unit Unit7;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections, MyListUnit;

type
  TForm7 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    FList   : TMyList2<TMyData>;

  private
    procedure PrintItem( AItem : TMyData );

  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

{$R *.dfm}

procedure GlobalPrintItem( AItem : TMyData );
begin
  Form7.Memo1.Lines.Add( Aitem.Value2 );
end;

procedure TForm7.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEach(
      procedure( Aitem : TMyData )
      begin
        Memo1.Lines.Add( Aitem.Value2 );
      end
    );

end;

procedure TForm7.Button2Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEach(
      procedure( Aitem : TMyData )
      begin
        if( Aitem.Value1 = 7 ) then
          Memo1.Lines.Add( Aitem.Value2 );

      end
    );

end;

procedure TForm7.Button3Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEach( PrintItem );
end;

procedure TForm7.Button4Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEach( GlobalPrintItem );
end;

procedure TForm7.FormCreate(Sender: TObject);
begin
  FList := TMyList2<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm7.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

procedure TForm7.PrintItem( AItem : TMyData );
begin
  Memo1.Lines.Add( Aitem.Value2 );
end;

end.
