unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections,
  MyListUnit;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FList   : TList<TMyData>;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  AValue : TMyData;

begin
  Memo1.Lines.Clear();
  for AValue in FList do
    Memo1.Lines.Add( AValue.Value2 );

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FList := TList<TMyData>.Create();

  PopulateTestList( FList );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

end.
