unit Unit11;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MyThreadingUnit, Vcl.StdCtrls;

type
  TForm10 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FThread : TMyThread1;

  public
    { Public declarations }
  end;

var
  Form10: TForm10;

implementation

{$R *.dfm}

procedure TForm10.FormCreate(Sender: TObject);
var
  ACounter : Integer;

begin
  ACounter := 0;

  FThread := TMyThread1.Create(
      procedure()
      begin
        FThread.Synchronize(
            procedure()
            begin
              Label1.Caption := IntToStr( ACounter );
            end
          );

        Inc( ACounter );
        Sleep( 1000 );
      end
    );

end;

procedure TForm10.FormDestroy(Sender: TObject);
begin
  FThread.Free();
end;

end.
